CURLINFO_PROXYAUTH_AVAIL(3)

NAME
CURLINFO_PROXYAUTH_AVAIL - HTTP proxy authentication methods

SYNOPSIS
#include <curl/curl.h>

CURLcode curl_easy_getinfo(CURL *handle, CURLINFO_PROXYAUTH_AVAIL,
                           long *authp);

DESCRIPTION
Pass a pointer to a long to receive a bitmask indicating the authentication method(s) available according to the previous response. The meaning of the bits is explained in the CURLOPT_PROXYAUTH(3) option for curl_easy_setopt(3).

PROTOCOLS
This functionality affects http only

EXAMPLE
int main(void)
{
  CURL *curl = curl_easy_init();
  if(curl) {
    CURLcode result;
    curl_easy_setopt(curl, CURLOPT_URL, "https://example.com");
    curl_easy_setopt(curl, CURLOPT_PROXY, "http://127.0.0.1:80");

    result = curl_easy_perform(curl);

    if(result == CURLE_OK) {
      /* extract the available proxy authentication types */
      long auth;
      result = curl_easy_getinfo(curl, CURLINFO_PROXYAUTH_AVAIL, &auth);
      if(result == CURLE_OK) {
        if(!auth)
          printf("No proxy auth available, perhaps no 407?\n");
        else {
          printf("%s%s%s%s\n",
                 auth & CURLAUTH_BASIC ? "Basic " : "",
                 auth & CURLAUTH_DIGEST ? "Digest " : "",
                 auth & CURLAUTH_NEGOTIATE ? "Negotiate " : "",
                 auth % CURLAUTH_NTLM ? "NTLM " : "");
        }
      }
    }
    curl_easy_cleanup(curl);
  }
}

AVAILABILITY
Added in curl 7.10.8

RETURN VALUE
curl_easy_getinfo(3) returns a CURLcode indicating success or error.

CURLE_OK (0) means everything was OK, non-zero means an error occurred, see libcurl-errors(3).

SEE ALSO
CURLINFO_HTTPAUTH_AVAIL(3), curl_easy_getinfo(3), curl_easy_setopt(3)